985N/A#!/bin/ksh -p
985N/A#
5524N/A# Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
985N/A# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
985N/A#
985N/A# This code is free software; you can redistribute it and/or modify it
985N/A# under the terms of the GNU General Public License version 2 only, as
985N/A# published by the Free Software Foundation.
985N/A#
985N/A# This code is distributed in the hope that it will be useful, but WITHOUT
985N/A# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
985N/A# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
985N/A# version 2 for more details (a copy is included in the LICENSE file that
985N/A# accompanied this code).
985N/A#
985N/A# You should have received a copy of the GNU General Public License version
985N/A# 2 along with this work; if not, write to the Free Software Foundation,
985N/A# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
985N/A#
2362N/A# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
2362N/A# or visit www.oracle.com if you need additional information or have any
2362N/A# questions.
985N/A#
985N/A
985N/A#
985N/A# @test
985N/A# @bug 6788096
985N/A# @summary Test simulates the case of multiple applets executed in
985N/A# the same VM and verifies that ImageIO shutdown hook
985N/A# StreamCloser does not cause a leak of classloaders.
985N/A#
985N/A# @build test.Main
985N/A# @build testapp.Main
985N/A# @run shell run_test.sh
985N/A
985N/A# There are several resources which need to be present before many
985N/A# shell scripts can run. Following are examples of how to check for
985N/A# many common ones.
985N/A#
985N/A# Note that the shell used is the Korn Shell, KSH
985N/A#
985N/A# Also note, it is recommended that make files NOT be used. Rather,
985N/A# put the individual commands directly into this file. That way,
985N/A# it is possible to use command line arguments and other shell tech-
985N/A# niques to find the compiler, etc on different systems. For example,
985N/A# a different path could be used depending on whether this were a
985N/A# Solaris or Win32 machine, which is more difficult (if even possible)
985N/A# in a make file.
985N/A
985N/A
985N/A# Beginning of subroutines:
985N/Astatus=1
985N/A
985N/A#Call this from anywhere to fail the test with an error message
985N/A# usage: fail "reason why the test failed"
985N/Afail()
985N/A { echo "The test failed :-("
985N/A echo "$*" 1>&2
985N/A echo "exit status was $status"
985N/A exit $status
985N/A } #end of fail()
985N/A
985N/A#Call this from anywhere to pass the test with a message
985N/A# usage: pass "reason why the test passed if applicable"
985N/Apass()
985N/A { echo "The test passed!!!"
985N/A echo "$*" 1>&2
985N/A exit 0
985N/A } #end of pass()
985N/A
985N/A# end of subroutines
985N/A
985N/A
985N/A# The beginning of the script proper
985N/A
985N/A# Checking for proper OS
985N/AOS=`uname -s`
985N/Acase "$OS" in
985N/A SunOS )
985N/A VAR="One value for Sun"
5524N/A DEFAULT_JDK=/
5524N/A FILESEP="/"
5524N/A PATHSEP=":"
5524N/A TMP="/tmp"
5524N/A ;;
5524N/A
5524N/A Linux )
5524N/A VAR="A different value for Linux"
5524N/A DEFAULT_JDK=/
985N/A FILESEP="/"
985N/A PATHSEP=":"
985N/A TMP="/tmp"
985N/A ;;
985N/A
5524N/A Darwin )
5524N/A VAR="A different value for MacOSX"
5524N/A DEFAULT_JDK=/usr
985N/A FILESEP="/"
985N/A PATHSEP=":"
985N/A TMP="/tmp"
985N/A ;;
985N/A
5524N/A Windows* )
985N/A VAR="A different value for Win32"
5524N/A DEFAULT_JDK="C:/Program Files/Java/jdk1.8.0"
985N/A FILESEP="\\"
985N/A PATHSEP=";"
985N/A TMP=`cd "${SystemRoot}/Temp"; echo ${PWD}`
985N/A ;;
985N/A
5524N/A CYGWIN* )
5524N/A VAR="A different value for Cygwin"
5524N/A DEFAULT_JDK="/cygdrive/c/Program\ Files/Java/jdk1.8.0"
5524N/A FILESEP="/"
5524N/A PATHSEP=";"
5524N/A TMP=`cd "${SystemRoot}/Temp"; echo ${PWD}`
5524N/A ;;
5524N/A
985N/A # catch all other OSs
985N/A * )
985N/A echo "Unrecognized system! $OS"
985N/A fail "Unrecognized system! $OS"
985N/A ;;
985N/Aesac
985N/A
985N/A# Want this test to run standalone as well as in the harness, so do the
985N/A# following to copy the test's directory into the harness's scratch directory
985N/A# and set all appropriate variables:
985N/A
985N/Aif [ -z "${TESTJAVA}" ] ; then
985N/A # TESTJAVA is not set, so the test is running stand-alone.
985N/A # TESTJAVA holds the path to the root directory of the build of the JDK
985N/A # to be tested. That is, any java files run explicitly in this shell
985N/A # should use TESTJAVA in the path to the java interpreter.
985N/A # So, we'll set this to the JDK spec'd on the command line. If none
985N/A # is given on the command line, tell the user that and use a cheesy
985N/A # default.
985N/A # THIS IS THE JDK BEING TESTED.
985N/A if [ -n "$1" ] ;
985N/A then TESTJAVA=$1
985N/A else echo "no JDK specified on command line so using default!"
4638N/A TESTJAVA=$DEFAULT_JDK
985N/A fi
985N/A TESTSRC=.
985N/A TESTCLASSES=.
985N/A STANDALONE=1;
985N/Afi
985N/Aecho "JDK under test is: $TESTJAVA"
985N/A
985N/A
985N/A############### YOUR TEST CODE HERE!!!!!!! #############
985N/A
985N/A#All files required for the test should be in the same directory with
985N/A# this file. If converting a standalone test to run with the harness,
985N/A# as long as all files are in the same directory and it returns 0 for
985N/A# pass, you should be able to cut and paste it into here and it will
985N/A# run with the test harness.
985N/A
985N/A# This is an example of running something -- test
985N/A# The stuff below catches the exit status of test then passes or fails
985N/A# this shell test as appropriate ( 0 status is considered a pass here )
985N/A
985N/Aecho "Create TestApp.jar..."
985N/A
985N/Aif [ -f TestApp.jar ] ; then
985N/A rm -f TestApp.jar
985N/Afi
985N/A
985N/A${TESTJAVA}/bin/jar -cvf TestApp.jar -C ${TESTCLASSES} testapp
985N/A
985N/Aif [ $? -ne "0" ] ; then
985N/A fail "Failed to create TestApp.jar"
985N/Afi
985N/A
985N/Aecho "Create Test.jar..."
985N/Aif [ -f Test.jar ] ; then
985N/A rm -f Test.jar
985N/Afi
985N/A
985N/A${TESTJAVA}/bin/jar -cvf Test.jar -C ${TESTCLASSES} test
985N/A
985N/Aif [ $? -ne 0 ] ; then
985N/A fail "Failed to create Test.jar"
985N/Afi
985N/A
985N/A# Prepare temp dir for cahce files
985N/Amkdir ./tmp
985N/Aif [ $? -ne 0 ] ; then
985N/A fail "Unable to create temp directory."
985N/Afi
985N/A
985N/A# Verify that all classoladers are destroyed
985N/A${TESTJAVA}/bin/java -cp Test.jar test.Main
985N/Aif [ $? -ne 0 ] ; then
985N/A fail "Test FAILED: some classloaders weren't destroyed."
985N/Afi
985N/A
985N/A
985N/A# Verify that ImageIO shutdown hook works correcly
985N/A${TESTJAVA}/bin/java -cp Test.jar -DforgetSomeStreams=true test.Main
985N/Aif [ $? -ne 0 ] ; then
985N/A fail "Test FAILED: some classloaders weren't destroyed of shutdown hook failed."
985N/Afi
985N/A
985N/A# sanity check: verify that all cache files were deleted
985N/Acache_files=`ls tmp`
985N/A
985N/Aif [ "x${cache_files}" != "x" ] ; then
985N/A echo "WARNING: some cache files was not deleted: ${cache_files}"
985N/Afi
985N/A
985N/Aecho "Test done."
985N/A
985N/Astatus=$?
985N/A
985N/Aif [ $status -eq "0" ] ; then
985N/A pass ""
985N/Aelse
985N/A fail "Test failed due to test plugin was not found."
985N/Afi
985N/A